+checkMakeTar() {
+ # Desc: Checks that a valid tar archive exists, creates one otherwise
+ # Usage: checkMakeTar [ path ]
+ # Version: 1.0.1
+ # Input: arg1: path of tar archive
+ # Output: exit code 0 : tar readable
+ # exit code 1 : tar missing; created
+ # exit code 2 : tar not readable; moved; replaced
+ # Depends: try, tar, date
+ local PATH_TAR returnFlag0 returnFlag1 returnFlag2
+ PATH_TAR="$1"
+
+ # Check if file is a valid tar archive
+ if tar --list --file="$PATH_TAR" 1>/dev/null 2>&1; then
+ ## T1: return success
+ returnFlag0="tar valid";
+ else
+ ## F1: Check if file exists
+ if [[ -f "$PATH_TAR" ]]; then
+ ### T: Rename file
+ try mv "$PATH_TAR" "$PATH_TAR""--broken--""$(date +%Y%m%dT%H%M%S)" && \
+ returnFlag1="tar moved";
+ else
+ ### F: -
+ :
+ fi
+ ## F2: Create tar archive, return 0
+ try tar --create --file="$PATH_TAR" --files-from=/dev/null && \
+ returnFlag2="tar created";
+ fi
+
+ # Determine function return code
+ if [[ "$returnFlag0" = "tar valid" ]]; then
+ return 0;
+ elif [[ "$returnFlag2" = "tar created" ]] && ! [[ "$returnFlag1" = "tar moved" ]]; then
+ return 1; # tar missing so created
+ elif [[ "$returnFlag2" = "tar created" ]] && [[ "$returnFlag1" = "tar moved" ]]; then
+ return 2; # tar not readable so moved; replaced
+ fi
+} # checks if arg1 is tar; creates one otherwise
+appendArgTar(){
+ # Desc: Writes first argument to temporary file with arguments as options, then appends file to tar
+ # Usage: appendArgTar "$(echo "Data to be written.")" [name of file to be inserted] [tar path] [temp dir] ([cmd1] [cmd2] [cmd3] [cmd4]...)
+ # Version: 1.0.3
+ # Input: arg1: data to be written
+ # arg2: file name of file to be inserted into tar
+ # arg3: tar archive path (must exist first)
+ # arg4: temporary working dir
+ # arg5+: command strings (ex: "gpsbabel -i nmea -f - -o kml -F - ")
+ # Output: file written to disk
+ # Example: decrypt multiple large files in parallel
+ # appendArgTar "$(cat /tmp/largefile1.gpg)" "largefile1" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # appendArgTar "$(cat /tmp/largefile2.gpg)" "largefile2" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # appendArgTar "$(cat /tmp/largefile3.gpg)" "largefile3" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # Depends: bash 5
+ # Ref/Attrib: Using 'eval' to construct command strings https://askubuntu.com/a/476533
+
+ # Save function name
+ local FN="${FUNCNAME[0]}";
+ #yell "DEBUG:STATUS:$FN:Finished appendArgTar()."
+
+ # Set file name
+ if ! [ -z "$2" ]; then FILENAME="$2"; else yell "ERROR:$FN:Not enough arguments."; exit 1; fi
+
+ # Check tar path is a file
+ if [ -f "$3" ]; then TAR_PATH="$3"; else yell "ERROR:$FN:Tar archive arg not a file."; exit 1; fi
+
+ # Check temp dir arg
+ if ! [ -z "$4" ]; then TMP_DIR="$4"; else yell "ERROR:$FN:No temporary working dir set."; exit 1; fi
+
+ # Set command strings
+ if ! [ -z "$5" ]; then CMD1="$5"; else CMD1="tee /dev/null "; fi # command string 1
+ if ! [ -z "$6" ]; then CMD2="$6"; else CMD2="tee /dev/null "; fi # command string 2
+ if ! [ -z "$7" ]; then CMD3="$7"; else CMD3="tee /dev/null "; fi # command string 3
+ if ! [ -z "$8" ]; then CMD4="$8"; else CMD4="tee /dev/null "; fi # command string 4
+
+ # Input command
+ CMD0="echo \"\$1\""
+
+ # # Debug
+ # yell "DEBUG:STATUS:$FN:CMD0:$CMD0"
+ # yell "DEBUG:STATUS:$FN:CMD1:$CMD1"
+ # yell "DEBUG:STATUS:$FN:CMD2:$CMD2"
+ # yell "DEBUG:STATUS:$FN:CMD3:$CMD3"
+ # yell "DEBUG:STATUS:$FN:CMD4:$CMD4"
+ # yell "DEBUG:STATUS:$FN:FILENAME:$FILENAME"
+ # yell "DEBUG:STATUS:$FN:TAR_PATH:$TAR_PATH"
+ # yell "DEBUG:STATUS:$FN:TMP_DIR:$TMP_DIR"
+
+ # Write to temporary working dir
+ eval "$CMD0"" | ""$CMD1"" | ""$CMD2"" | ""$CMD3"" | ""$CMD4" > "$TMP_DIR"/"$FILENAME";
+
+ # Append to tar
+ try tar --append --directory="$TMP_DIR" --file="$TAR_PATH" "$FILENAME";
+ #yell "DEBUG:STATUS:$FN:Finished appendArgTar()."
+} # Append Bash var to file appended to Tar archive
+appendFileTar(){
+ # Desc: Processes first file and then appends to tar
+ # Usage: appendFileTar [file path] [name of file to be inserted] [tar path] [temp dir] ([cmd1] [cmd2] [cmd3] [cmd4]...)
+ # Version: 1.0.2
+ # Input: arg1: path of file to be (processed and) written
+ # arg2: name to use for file inserted into tar
+ # arg3: tar archive path (must exist first)
+ # arg4: temporary working dir
+ # arg5+: command strings (ex: "gpsbabel -i nmea -f - -o kml -F - ")
+ # Output: file written to disk
+ # Example: decrypt multiple large files in parallel
+ # appendFileTar /tmp/largefile1.gpg "largefile1" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # appendFileTar /tmp/largefile2.gpg "largefile2" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # appendFileTar /tmp/largefile3.gpg "largefile3" $HOME/archive.tar /tmp "gpg --decrypt" &
+ # Depends: bash 5
+
+ # Save function name
+ local FN="${FUNCNAME[0]}";
+ #yell "DEBUG:STATUS:$FN:Finished appendFileTar()."
+
+ # Set file name
+ if ! [ -z "$2" ]; then FILENAME="$2"; else yell "ERROR:$FN:Not enough arguments."; exit 1; fi
+ # Check tar path is a file
+ if [ -f "$3" ]; then TAR_PATH="$3"; else yell "ERROR:$FN:Tar archive arg not a file."; exit 1; fi
+ # Check temp dir arg
+ if ! [ -z "$4" ]; then TMP_DIR="$4"; else yell "ERROR:$FN:No temporary working dir set."; exit 1; fi
+ # Set command strings
+ if ! [ -z "$5" ]; then CMD1="$5"; else CMD1="tee /dev/null "; fi # command string 1
+ if ! [ -z "$6" ]; then CMD2="$6"; else CMD2="tee /dev/null "; fi # command string 2
+ if ! [ -z "$7" ]; then CMD3="$7"; else CMD3="tee /dev/null "; fi # command string 3
+ if ! [ -z "$8" ]; then CMD4="$8"; else CMD4="tee /dev/null "; fi # command string 4
+
+ # Input command string
+ CMD0="cat \"\$1\""
+
+ # # Debug
+ # yell "DEBUG:STATUS:$FN:CMD0:$CMD0"
+ # yell "DEBUG:STATUS:$FN:CMD1:$CMD1"
+ # yell "DEBUG:STATUS:$FN:CMD2:$CMD2"
+ # yell "DEBUG:STATUS:$FN:CMD3:$CMD3"
+ # yell "DEBUG:STATUS:$FN:CMD4:$CMD4"
+ # yell "DEBUG:STATUS:$FN:FILENAME:$FILENAME"
+ # yell "DEBUG:STATUS:$FN:TAR_PATH:$TAR_PATH"
+ # yell "DEBUG:STATUS:$FN:TMP_DIR:$TMP_DIR"
+
+ # Write to temporary working dir
+ eval "$CMD0 | $CMD1 | $CMD2 | $CMD3 | $CMD4" > "$TMP_DIR"/"$FILENAME";
+
+ # Append to tar
+ try tar --append --directory="$TMP_DIR" --file="$TAR_PATH" "$FILENAME";
+ #yell "DEBUG:STATUS:$FN:Finished appendFileTar()."
+} # Append file to Tar archive
+magicWriteVersion() {
+ # Desc: Appends time-stamped VERSION to PATHOUT_TAR
+ # Usage: magicWriteVersion
+ # Version: 0.1.0
+ # Input: CONTENT_VERSION, FILEOUT_VERSION, PATHOUT_TAR, DIR_TMP
+ # Input: SCRIPT_VERSION, SCRIPT_URL, AGE_VERSION, AGE_URL, SCRIPT_HOSTNAME
+ # Output: appends tar PATHOUT_TAR
+ # Depends: dateTimeShort, appendArgTar
+ local CONTENT_VERSION pubKeyIndex
+
+ # Set VERSION file name
+ FILEOUT_VERSION="$(dateTimeShort)..VERSION";
+
+ # Gather VERSION data in CONTENT_VERSION
+ CONTENT_VERSION="SCRIPT_VERSION=$SCRIPT_VERSION";
+ #CONTENT_VERSION="$CONTENT_VERSION""\\n";
+ CONTENT_VERSION="$CONTENT_VERSION""\\n""SCRIPT_NAME=$SCRIPT_NAME";
+ CONTENT_VERSION="$CONTENT_VERSION""\\n""SCRIPT_URL=$SCRIPT_URL";
+ CONTENT_VERSION="$CONTENT_VERSION""\\n""AGE_VERSION=$AGE_VERSION";
+ CONTENT_VERSION="$CONTENT_VERSION""\\n""AGE_URL=$AGE_URL";
+ CONTENT_VERSION="$CONTENT_VERSION""\\n""DATE=$(date --iso-8601=seconds)";
+ CONTENT_VERSION="$CONTENT_VERSION""\\n""HOSTNAME=$SCRIPT_HOSTNAME";
+ ## Add list of recipient pubkeys
+ for pubkey in "${recPubKeysValid[@]}"; do
+ ((pubKeyIndex++))
+ CONTENT_VERSION="$CONTENT_VERSION""\\n""PUBKEY_$pubKeyIndex=$pubkey";
+ done
+ ## Process newline escapes
+ CONTENT_VERSION="$(echo -e "$CONTENT_VERSION")"
+
+ # Write CONTENT_VERSION as file FILEOUT_VERSION and write-append to PATHOUT_TAR
+ appendArgTar "$CONTENT_VERSION" "$FILEOUT_VERSION" "$PATHOUT_TAR" "$DIR_TMP";
+
+} # bkgpslog: write version data to PATHOUT_TAR via appendArgTar()
+magicGatherWriteBuffer() {
+ # Desc: bkgpslog-specific meta function for writing data to DIR_TMP then appending each file to PATHOUT_TAR
+ # Inputs: PATHOUT_TAR FILEOUT_{NMEA,GPX,KML} CMD_CONV_{NMEA,GPX,KML} CMD_{COMPRESS,ENCRYPT} DIR_TMP,
+ # Inputs: BUFFER_TTL bufferTTL_STR SCRIPT_HOSTNAME CMD_COMPRESS_SUFFIX CMD_ENCRYPT_SUFFIX
+ # Depends: yell, try, vbm, appendArgTar, tar
+ local FN="${FUNCNAME[0]}";
+ wait; # Wait to avoid collision with older magicWriteBuffer() instances (see https://www.tldp.org/LDP/abs/html/x9644.html )
+ # Create buffer file with unique name
+ PATHOUT_BUFFER="$DIR_TMP/buffer$SECONDS";
+ # Fill buffer
+ timeout "$BUFFER_TTL"s gpspipe -r -o "$PATHOUT_BUFFER" ;
+ timeBufferStart="$(dateTimeShort "$(date --date="$BUFFER_TTL seconds ago")")"; # Note start time
+ vbm "DEBUG:STATUS:$FN:Started magicWriteBuffer().";
+ # Determine file paths (time is start of buffer period)
+ FILEOUT_BASENAME="$timeBufferStart""--""$bufferTTL_STR""..""$SCRIPT_HOSTNAME""_location" && vbm "STATUS:Set FILEOUT_BASENAME to:$FILEOUT_BASENAME";
+ ## Files saved to DIR_TMP
+ FILEOUT_NMEA="$FILEOUT_BASENAME".nmea"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set FILEOUT_NMEA to:$FILEOUT_NMEA";
+ FILEOUT_GPX="$FILEOUT_BASENAME".gpx"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set FILEOUT_GPX to:$FILEOUT_GPX";
+ FILEOUT_KML="$FILEOUT_BASENAME".kml"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set FILEOUT_KML to:$FILEOUT_KML";
+ PATHOUT_NMEA="$DIR_TMP"/"$FILEOUT_NMEA" && vbm "STATUS:Set PATHOUT_NMEA to:$PATHOUT_NMEA";
+ PATHOUT_GPX="$DIR_TMP"/"$FILEOUT_GPX" && vbm "STATUS:Set PATHOUT_GPX to:$PATHOUT_GPX";
+ PATHOUT_KML="$DIR_TMP"/"$FILEOUT_KML" && vbm "STATUS:Set PATHOUT_KML to:$PATHOUT_KML";
+ ## Files saved to disk (DIR_OUT)
+ ### one file per day (Ex: "20200731..hostname_location.[.gpx.gz].tar")
+ PATHOUT_TAR="$DIR_OUT"/"$(dateShort "$(date --date="$BUFFER_TTL seconds ago")")".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar && \
+ vbm "STATUS:Set PATHOUT_TAR to:$PATHOUT_TAR";
+ # DEBUG: check vars
+ vbm "STATUS:DIR_TMP :$DIR_TMP";
+ vbm "STATUS:PATHOUT_TAR :$PATHOUT_TAR";
+ vbm "STATUS:PATHOUT_NMEA:$PATHOUT_NMEA";
+ vbm "STATUS:PATHOUT_GPX:$PATHOUT_GPX";
+ vbm "STATUS:PATHOUT_KML:$PATHOUT_KML";
+
+
+ # Validate PATHOUT_TAR as tar.
+ checkMakeTar "$PATHOUT_TAR";
+ ## Add VERSION file if checkMakeTar had to create a tar (exited 1) or replace one (exited 2)
+ if [[ $? -eq 1 ]] || [[ $? -eq 2 ]]; then magicWriteVersion; fi
+
+ # Write bufferBash to PATHOUT_TAR
+ appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_NMEA" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_NMEA" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write NMEA data
+ appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_GPX" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_GPX" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write GPX file
+ appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_KML" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_KML" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write KML file
+
+ # Remove secured chunks from DIR_TMP
+ rm "$PATHOUT_BUFFER" "$PATHOUT_NMEA" "$PATHOUT_GPX" "$PATHOUT_KML";
+ vbm "DEBUG:STATUS:$FN:Finished magicWriteBuffer().";
+} # write buffer to disk
+